Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traadv_cen2_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traadv_cen2_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traadv_cen2_tam.F90	(revision 2587)
@@ -127,5 +127,7 @@
    PUBLIC   tra_adv_cen2_adj    ! routine called by traadv_tam.F90
    PUBLIC   tra_adv_cen2_adj_tst! routine called by tst.F90
+#if defined key_tst_tlm
    PUBLIC   tra_adv_cen2_tlm_tst! routine called by tamtst.F90
+#endif
 
    REAL(wp), DIMENSION(jpi,jpj) ::  &
@@ -935,5 +937,5 @@
 
    END SUBROUTINE tra_adv_cen2_adj_tst
-
+#if defined key_tst_tlm
 SUBROUTINE tra_adv_cen2_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -968,4 +970,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -1027,5 +1030,5 @@
          & z3r
       CHARACTER(LEN=14)   :: cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
       CHARACTER (LEN=90)  :: FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -1084,7 +1087,8 @@
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_tradv_cen2'
       CALL tlm_namrd
       gamma = h_ratio     
+      file_wop='trj_wop_tradv_cen2'
+      file_xdx='trj_xdx_tradv_cen2'   
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -1151,5 +1155,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 ) CALL istate_p  
 
       ! *** initialize the reference trajectory
@@ -1184,16 +1188,11 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------
-      CALL tra_adv_cen2(nit000, un, vn, wn)
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch /= 2 ) CALL tra_adv_cen2(nit000, un, vn, wn)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------    
-         zta_out  (:,:,:) = ta   (:,:,:)
-         zsa_out  (:,:,:) = sa   (:,:,:)          
-
+      IF ( tlm_bch == 2 ) THEN       
          !--------------------------------------------------------------------
          ! Initialize the tangent variables: dy^* = W dy  
@@ -1214,18 +1213,17 @@
          ! Compute the scalar product: ( L(t0,tn) gamma dx0 ) )
          !--------------------------------------------------------------------
-
          zsp2_Ta    = DOT_PRODUCT( ta_tl, ta_tl  )
          zsp2_Sa    = DOT_PRODUCT( sa_tl, sa_tl  )
 
          zsp2      = zsp2_Ta + zsp2_Sa
-  
          !--------------------------------------------------------------------
          !  Storing data
          !--------------------------------------------------------------------
          CALL trj_rd_spl(file_wop) 
-
          zta_wop  (:,:,:) = ta  (:,:,:)
          zsa_wop  (:,:,:) = sa  (:,:,:)
-
+         CALL trj_rd_spl(file_xdx) 
+         zta_out  (:,:,:) = ta  (:,:,:)
+         zsa_out  (:,:,:) = sa  (:,:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -1372,5 +1370,5 @@
   END SUBROUTINE  tra_adv_cen2_tlm_tst
 #endif
-
+#endif
    !!======================================================================
 END MODULE traadv_cen2_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traadv_eiv_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traadv_eiv_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traadv_eiv_tam.F90	(revision 2587)
@@ -23,7 +23,7 @@
       & wp
    USE par_oce       , ONLY: & ! Ocean space and time domain variables
-      & jpi,                 &
-      & jpj,                 & 
-      & jpk 
+      & jpi, jpj, jpk 
+   USE in_out_manager, ONLY: & ! I/O manager 
+      & lwp, numout              
 
    IMPLICIT NONE
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traadv_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traadv_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traadv_tam.F90	(revision 2587)
@@ -43,13 +43,11 @@
       & tra_adv_cen2_tan,     &
       & tra_adv_cen2_adj,     &
-      & tra_adv_cen2_adj_tst, &
-      & tra_adv_cen2_tlm_tst
+#if defined key_tst_tlm
+      & tra_adv_cen2_tlm_tst, &
+#endif
+      & tra_adv_cen2_adj_tst
    USE traadv_eiv_tam, ONLY: & ! advection trend - eddy induced velocity (tra_adv_eiv   routine)
       & tra_adv_eiv_tan,     &
       & tra_adv_eiv_adj
-!   USE in_out_manager, ONLY : & ! I/O manager 
-!      & lwp,                  &
-!      & numout,               &
-!      & nit000
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
@@ -62,5 +60,7 @@
    PUBLIC   tra_adv_ctl_tam ! routine called by stepadj module
    PUBLIC   tra_adv_adj_tst ! routine called by tst module
+#if defined key_tst_tlm
    PUBLIC   tra_adv_tlm_tst ! routine called by tst module
+#endif
    !!* Namelist nam_traadv
    LOGICAL, PUBLIC ::   ln_traadv_cen2   = .TRUE.       ! 2nd order centered scheme flag
@@ -305,5 +305,5 @@
       !
    END SUBROUTINE tra_adv_ctl_tam
-
+#if defined key_tst_tlm
 SUBROUTINE tra_adv_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -335,4 +335,5 @@
    END SUBROUTINE tra_adv_tlm_tst
 #endif
+#endif
 
 
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traldf_lap_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traldf_lap_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traldf_lap_tam.F90	(revision 2587)
@@ -106,5 +106,7 @@
    PUBLIC tra_ldf_lap_adj      ! routine called by tradldf_tam.F90
    PUBLIC tra_ldf_lap_adj_tst  ! routine called by tradldf_tam.F90
+#if defined key_tst_tlm
    PUBLIC tra_ldf_lap_tlm_tst  
+#endif
 
    !! * Substitutions
@@ -735,5 +737,5 @@
 
    END SUBROUTINE tra_ldf_lap_adj_tst
-
+#if defined key_tst_tlm
    SUBROUTINE tra_ldf_lap_tlm_tst ( kumadt )
       !!-----------------------------------------------------------------------
@@ -775,8 +777,9 @@
         & lk_c1d
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
       USE istate_mod
-      USE wzvmod             !  vertical velocity
+      USE zpshde
       USE gridrandom, ONLY: &
         & grid_rd_sd
@@ -785,5 +788,5 @@
         & tb, sb, tn, sn, ta,  &
         & sa, gtu, gsu, gtv,   &
-        & gsv
+        & gsv, gru, grv, rhd
       USE traldf_lap          ! lateral mixing                   (tra_ldf routine)
       USE opatam_tst_ini, ONLY: &
@@ -877,5 +880,5 @@
          & z2r               ! 2D random field 
       CHARACTER(LEN=14) ::   cl_name
-      CHARACTER (LEN=128) :: file_out_sc, file_wop, file_out
+      CHARACTER (LEN=128) :: file_out_sc, file_wop, file_out, file_xdx
       CHARACTER (LEN=90) :: &
          & FMT
@@ -972,5 +975,5 @@
       zgtv_wop(:,:)    = 0.0_wp
       zgsv_wop(:,:)    = 0.0_wp
-
+      IF ( tlm_bch == 2 ) THEN      
       tb_tl(:,:,:) = 0.0_wp
       sb_tl(:,:,:) = 0.0_wp
@@ -981,5 +984,5 @@
       gtv_tl(:,:)  = 0.0_wp
       gsv_tl(:,:)  = 0.0_wp
-
+      ENDIF
       zsctb(:)     = 0.0_wp
       zscta(:)     = 0.0_wp
@@ -1002,7 +1005,8 @@
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_tldf_lap'
       CALL tlm_namrd
       gamma = h_ratio
+      file_wop='trj_wop_tldf_lap'
+      file_xdx='trj_xdx_tldf_lap'
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -1069,5 +1073,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 )      CALL istate_p  
 
       ! *** initialize the reference trajectory
@@ -1076,4 +1080,7 @@
       CALL  trj_rea( nit000, 1 )
 
+      ! Compute  gtu, gsu, gtv, gsv
+      CALL zps_hde(nit000, tn, sn, rhd, gtu, gsu, gru, gtv, gsv, grv)
+
       IF (( cur_loop .NE. 0) .OR. ( gamma .NE. 0.0_wp) )THEN
          ztb_tlin(:,:,:) = gamma * ztb_tlin(:,:,:)
@@ -1101,27 +1108,15 @@
          gsv(:,:)       = gsv(:,:) + zgsv_tlin(:,:)
       ENDIF 
-      IF( .NOT. lk_vvl ) CALL wzv(nit000)
+
       !--------------------------------------------------------------------
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------
-      CALL tra_ldf_lap( nit000 )
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
-
+      IF ( tlm_bch /= 2 )      CALL tra_ldf_lap( nit000 )
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------
-         ztb_out  (:,:,:) = tb   (:,:,:)
-         zsb_out  (:,:,:) = sb   (:,:,:)
-         zta_out  (:,:,:) = ta   (:,:,:)
-         zsa_out  (:,:,:) = sa   (:,:,:)
-         zgtu_out (:,:  ) = gtu  (:,:  )    
-         zgsu_out (:,:  ) = gsu  (:,:  )
-         zgtv_out (:,:  ) = gtv  (:,:  )    
-         zgsv_out (:,:  ) = gsv  (:,:  )      
-
+      IF ( tlm_bch == 2 ) THEN    
          !--------------------------------------------------------------------
          ! Initialize the tangent variables: dy^* = W dy  
@@ -1171,5 +1166,13 @@
          zgtv_wop (:,:  ) = gtv (:,:  )
          zgsv_wop (:,:  ) = gsv (:,:  )
-
+         CALL trj_rd_spl(file_xdx) 
+         ztb_out  (:,:,:) = tb  (:,:,:)
+         zsb_out  (:,:,:) = sb  (:,:,:)
+         zta_out  (:,:,:) = ta  (:,:,:)
+         zsa_out  (:,:,:) = sa  (:,:,:)
+         zgtu_out (:,:  ) = gtu (:,:  )
+         zgsu_out (:,:  ) = gsu (:,:  )
+         zgtv_out (:,:  ) = gtv (:,:  )
+         zgsv_out (:,:  ) = gsv (:,:  )
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -1628,5 +1631,5 @@
       CALL iom_close( inum )
    END SUBROUTINE asm_trj_wop_rd
-
+#endif
 #endif
    !!==============================================================================
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traldf_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traldf_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traldf_tam.F90	(revision 2587)
@@ -11,4 +11,5 @@
    !!          9.0  ! 08-06 (A. Vidard) Skeleton
    !!          9.0  ! 09-03 (F. Vigilant) adding tra_ldf_lap option
+   !!          9.0  ! 10-06 (P.A. Bouttier) adding tra_ldf_bilap option
    !!----------------------------------------------------------------------
 
@@ -25,6 +26,11 @@
       & tra_ldf_lap_tan,     &
       & tra_ldf_lap_adj,     &
-      & tra_ldf_lap_adj_tst, &
-      & tra_ldf_lap_tlm_tst
+#if defined key_tst_tlm
+      & tra_ldf_lap_tlm_tst, &
+#endif
+      & tra_ldf_lap_adj_tst
+   USE traldf_bilap_tam, ONLY: & !lateral mixing                (tra_ldf_bilap routine)
+      & tra_ldf_bilap_tan,   &
+      & tra_ldf_bilap_adj
    USE in_out_manager, ONLY: & ! I/O manager
       & ctl_stop, nit000, lwp, numout, nitend
@@ -50,5 +56,8 @@
    PUBLIC   tra_ldf_adj     ! called by step_tam.F90 
    PUBLIC   tra_ldf_adj_tst ! called by tamtst.F90 
+#if defined key_tst_tlm
    PUBLIC   tra_ldf_tlm_tst ! called by tamtst.F90 
+#endif
+   PUBLIC   ldf_ctl_tam     ! called by trazdf_imp (init of l_traldf_rot)
 
    INTEGER ::  nldf
@@ -76,4 +85,5 @@
       CASE ( 0 )   ;   CALL tra_ldf_lap_tan   ( kt )      ! iso-level laplacian
       CASE ( 1 )   ;   CALL tra_ldf_iso_tan   ( kt )      ! rotated laplacian (except dk[ dk[.] ] part)
+      CASE ( 2 )   ;   CALL tra_ldf_bilap_tan ( kt )      ! iso-level bilaplacian
       END SELECT
    END SUBROUTINE tra_ldf_tan
@@ -94,4 +104,5 @@
       CASE ( 0 )   ;   CALL tra_ldf_lap_adj   ( kt )      ! rotated laplacian (except dk[ dk[.] ] part)
       CASE ( 1 )   ;   CALL tra_ldf_iso_adj   ( kt )      ! rotated laplacian (except dk[ dk[.] ] part)
+      CASE ( 2 )   ;   CALL tra_ldf_bilap_adj ( kt )      ! iso-level bilaplacian
       END SELECT
       !
@@ -206,8 +217,18 @@
 
       IF( ln_traldf_bilap ) THEN      ! bilaplacian operator
-           CALL ctl_stop( '          You shouldn t have seen this error message, ln_trad_bilap option not impemented yet for tam' )
+         IF ( ln_zco ) THEN                ! z-coordinate
+            IF ( ln_traldf_level )   nldf = 2      ! iso-level  (no rotation)
+            IF ( ln_traldf_hor   )   nldf = 2      ! horizontal (no rotation)
+            IF ( ln_traldf_iso   )   ierr = 2      ! isoneutral (   rotation)
+      ENDIF
+         IF ( ln_zps ) THEN             ! z-coordinate
+            IF ( ln_traldf_level )   ierr = 1      ! iso-level not allowed 
+            IF ( ln_traldf_hor   )   nldf = 2      ! horizontal (no rotation)
+            IF ( ln_traldf_iso   )   ierr = 2      ! isoneutral (   rotation)
+         ENDIF
       ENDIF
 
       IF( ierr == 1 )   CALL ctl_stop( ' iso-level in z-coordinate - partial step, not allowed' )
+      IF( ierr == 2 )   CALL ctl_stop( ' isoneutral bilaplacian operator does not exist' )
       IF( lk_traldf_eiv .AND. .NOT.ln_traldf_iso )   &
            CALL ctl_stop( '          eddy induced velocity on tracers',   &
@@ -227,5 +248,5 @@
    END SUBROUTINE ldf_ctl_tam
 
-
+#if defined key_tst_tlm
    SUBROUTINE tra_ldf_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -266,3 +287,4 @@
    !!======================================================================
 #endif
+#endif
 END MODULE traldf_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/tranxt_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/tranxt_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/tranxt_tam.F90	(revision 2587)
@@ -229,5 +229,4 @@
       !
    END SUBROUTINE tra_nxt_tan
-
    SUBROUTINE tra_nxt_adj( kt )
       !!----------------------------------------------------------------------
@@ -476,16 +475,4 @@
       ! Reset the tangent and adjoint variables
       !--------------------------------------------------------------------
-      zsa_tlin(:,:,:) = 0.0_wp 
-      zta_tlin(:,:,:) = 0.0_wp 
-      zsb_tlin(:,:,:) = 0.0_wp 
-      ztb_tlin(:,:,:) = 0.0_wp 
-      zsn_tlin(:,:,:) = 0.0_wp 
-      ztn_tlin(:,:,:) = 0.0_wp 
-      zsa_adin(:,:,:) = 0.0_wp 
-      zta_adin(:,:,:) = 0.0_wp 
-      zsb_adin(:,:,:) = 0.0_wp 
-      ztb_adin(:,:,:) = 0.0_wp 
-      zsn_adin(:,:,:) = 0.0_wp 
-      ztn_adin(:,:,:) = 0.0_wp 
       sb_tl(:,:,:) = 0.0_wp
       tb_tl(:,:,:) = 0.0_wp
@@ -500,4 +487,10 @@
       sn_ad(:,:,:) = 0.0_wp
       tn_ad(:,:,:) = 0.0_wp
+      zsb_tlin(:,:,:) = 0.0_wp
+      ztb_tlin(:,:,:) = 0.0_wp
+      zsa_tlin(:,:,:) = 0.0_wp
+      zta_tlin(:,:,:) = 0.0_wp
+      zsn_tlin(:,:,:) = 0.0_wp
+      ztn_tlin(:,:,:) = 0.0_wp
 
       DO jj = 1, jpj
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traqsr_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traqsr_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/traqsr_tam.F90	(revision 2587)
@@ -277,6 +277,5 @@
                   DO ji = fs_2, fs_jpim1   ! vector opt.
                      ! qsr trend
-                     qsr_ad(ji,jj) = qsr_ad(ji,jj) + ta_ad(ji,jj,jk) * zc0   &
-                                   &   * ( gdsr(jk)*tmask(ji,jj,jk) - gdsr(jk+1)*tmask(ji,jj,jk+1) )
+                     qsr_ad(ji,jj) = qsr_ad(ji,jj) + ta_ad(ji,jj,jk) * zc0 * ( gdsr(jk)*tmask(ji,jj,jk) - gdsr(jk+1)*tmask(ji,jj,jk+1) )
                   END DO
                END DO
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/trasbc_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/trasbc_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/trasbc_tam.F90	(revision 2587)
@@ -96,5 +96,7 @@
    PUBLIC   tra_sbc_adj     ! routine called by step_tam.F90
    PUBLIC   tra_sbc_adj_tst ! routine called by tst.F90
+#if defined key_tst_tlm
    PUBLIC   tra_sbc_tlm_tst ! routine calle  by tamtst.F90
+#endif
 
    !! * Substitutions
@@ -579,5 +581,5 @@
    END SUBROUTINE tra_sbc_adj_tst
 
-
+#if defined key_tst_tlm
    SUBROUTINE tra_sbc_tlm_tst ( kumadt ) 
       !!-----------------------------------------------------------------------
@@ -612,4 +614,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -676,5 +679,5 @@
          & zgsp7 
       CHARACTER (LEN=14)  :: cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
       CHARACTER (LEN=90)  ::  FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -731,7 +734,8 @@
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_trasbc'
       CALL tlm_namrd
       gamma = h_ratio
+      file_wop='trj_wop_trasbc'
+      file_xdx='trj_xdx_trasbc'
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -778,5 +782,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 )      CALL istate_p  
 
       ! *** initialize the reference trajectory
@@ -804,18 +808,11 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------
-      CALL tra_sbc(nit000)
-
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
-
+      IF ( tlm_bch /= 2 ) CALL tra_sbc(nit000)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------  
-         zta_out  (:,:,:) = ta   (:,:,:)
-         zsa_out  (:,:,:) = sa   (:,:,:)          
-
+      IF ( tlm_bch == 2 ) THEN         
          !--------------------------------------------------------------------
          ! Initialize the tangent variables: dy^* = W dy  
@@ -836,5 +833,4 @@
          ! Compute the scalar product: ( L(t0,tn) gamma dx0 ) )
          !--------------------------------------------------------------------
-
          zsp2_1    = DOT_PRODUCT( ta_tl, ta_tl  )
          zsp2_2    = DOT_PRODUCT( sa_tl, sa_tl  )
@@ -847,4 +843,7 @@
          zta_wop  (:,:,:) = ta  (:,:,:)
          zsa_wop  (:,:,:) = sa  (:,:,:)
+         CALL trj_rd_spl(file_xdx) 
+         zta_out  (:,:,:) = ta  (:,:,:)
+         zsa_out  (:,:,:) = sa  (:,:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -981,3 +980,4 @@
 !!======================================================================
 #endif
+#endif
 END MODULE trasbc_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/trazdf_imp_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/trazdf_imp_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/trazdf_imp_tam.F90	(revision 2587)
@@ -74,11 +74,14 @@
       & ahtw,                &
       & aht0
+#if defined key_ldfslp
    USE ldfslp        , ONLY: & ! lateral physics: slope of diffusion
       & wslpi,               & !: i_slope at W-points
       & wslpj                  !: j-slope at W-points
+#endif 
 #if defined key_zdfddm
    USE zdfddm        , ONLY: &
       & avs
 #endif 
+   USE traldf_tam
    USE in_out_manager, ONLY: & ! I/O manager 
       & lwp,          &
@@ -106,5 +109,7 @@
    PUBLIC tra_zdf_imp_adj       !  routine called by tra_zdf_adj.F90
    PUBLIC tra_zdf_imp_adj_tst   !  routine called by tst.F90
+#if defined key_tst_tlm
    PUBLIC tra_zdf_imp_tlm_tst   !  routine called by tamtst.F90 
+#endif
 
    !! * Substitutions
@@ -483,8 +488,9 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( kt == nitend ) THEN
          IF(lwp)WRITE(numout,*)
          IF(lwp)WRITE(numout,*) 'tra_zdf_imp_adj : implicit vertical mixing'
          IF(lwp)WRITE(numout,*) '~~~~~~~~~~~~~~~ '
+         CALL ldf_ctl_tam  ! init of l_traldf_rot
          zavi = 0._wp      ! avoid warning at compilation phase when lk_ldfslp=F
       ENDIF
@@ -985,5 +991,5 @@
 
    END SUBROUTINE tra_zdf_imp_adj_tst
-
+#if defined key_tst_tlm
    SUBROUTINE tra_zdf_imp_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -1019,4 +1025,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -1077,5 +1084,5 @@
       CHARACTER(LEN=14) ::&
          & cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
       CHARACTER (LEN=90) :: &
          & FMT
@@ -1126,7 +1133,8 @@
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_trazdf_imp'
       CALL tlm_namrd
       gamma = h_ratio
+      file_wop='trj_wop_trazdf_imp'
+      file_xdx='trj_xdx_trazdf_imp'
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -1169,5 +1177,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 )      CALL istate_p  
 
       ! *** initialize the reference trajectory
@@ -1192,17 +1200,11 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------
-      CALL tra_zdf_imp(nit000, rdttra)
-
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
-
+      IF ( tlm_bch /= 2 )  CALL tra_zdf_imp(nit000, rdttra)
+      IF ( tlm_bch == 0 )  CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 )  CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------  
-         zta_out  (:,:,:) = ta   (:,:,:)
-         zsa_out  (:,:,:) = sa   (:,:,:)
+      IF ( tlm_bch == 2 ) THEN
          !--------------------------------------------------------------------
          ! Initialize the tangent variables: dy^* = W dy  
@@ -1235,5 +1237,7 @@
          zta_wop  (:,:,:) = ta  (:,:,:)
          zsa_wop  (:,:,:) = sa  (:,:,:)
-
+         CALL trj_rd_spl(file_xdx) 
+         zta_out  (:,:,:) = ta  (:,:,:)
+         zsa_out  (:,:,:) = sa  (:,:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -1378,3 +1382,4 @@
    END SUBROUTINE tra_zdf_imp_tlm_tst
 #endif
+#endif
 END MODULE trazdf_imp_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/trazdf_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/trazdf_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/trazdf_tam.F90	(revision 2587)
@@ -46,6 +46,8 @@
       & tra_zdf_imp_tan,     &
       & tra_zdf_imp_adj,     &
-      & tra_zdf_imp_adj_tst, &
-      & tra_zdf_imp_tlm_tst
+#if defined key_tst_tlm
+      & tra_zdf_imp_tlm_tst, &
+#endif
+      & tra_zdf_imp_adj_tst
    USE in_out_manager, ONLY: & ! I/O manager 
       & lwp,                 &
@@ -63,7 +65,8 @@
       & tra_zdf_tan, &
       & tra_zdf_adj         ! routines called by step_tam.F90
-   PUBLIC  &
-      & tra_zdf_adj_tst, &  ! routine called by tst.F90
-      & tra_zdf_tlm_tst     ! routine called by tst.F90 
+   PUBLIC  tra_zdf_adj_tst  ! routine called by tst.F90
+#if defined key_tst_tlm
+   PUBLIC  tra_zdf_tlm_tst     ! routine called by tst.F90 
+#endif
    INTEGER ::   nzdf = 0               ! type vertical diffusion algorithm used
       !                                ! defined from ln_zdf...  namlist logicals)
@@ -247,5 +250,5 @@
 
    END SUBROUTINE zdf_ctl_tam
-
+#if defined key_tst_tlm
    SUBROUTINE tra_zdf_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -282,3 +285,4 @@
    END SUBROUTINE tra_zdf_tlm_tst
 #endif
+#endif
 END MODULE trazdf_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/zpshde_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/zpshde_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/TRA/zpshde_tam.F90	(revision 2587)
@@ -78,5 +78,7 @@
    PUBLIC zps_hde_adj      ! routine called by step_tam.F90
    PUBLIC zps_hde_adj_tst  ! routine called by tst.F90
+#if defined key_tst_tlm
    PUBLIC  zps_hde_tlm_tst ! routine called by tamtst.F90
+#endif
 
    !! * module variables
@@ -946,5 +948,5 @@
       
    END SUBROUTINE zps_hde_adj_tst
-
+#if defined key_tst_tlm
    SUBROUTINE zps_hde_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -984,4 +986,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -1049,5 +1052,5 @@
          & zgsp7
       CHARACTER(LEN=14)   :: cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
       CHARACTER (LEN=90)  ::  FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -1104,4 +1107,5 @@
       zgru_out(:,:)   = 0.0_wp    
       zgrv_out(:,:)   = 0.0_wp
+      IF ( tlm_bch == 2 ) THEN
       gtu_tl(:,:)     = 0.0_wp
       gtv_tl(:,:)     = 0.0_wp    
@@ -1110,5 +1114,5 @@
       gru_tl(:,:)     = 0.0_wp    
       grv_tl(:,:)     = 0.0_wp 
-
+      ENDIF
       zscgtu(:)         = 0.0_wp
       zscgtv(:)         = 0.0_wp
@@ -1132,7 +1136,8 @@
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_zps'
       CALL tlm_namrd
       gamma = h_ratio
+      file_wop='trj_wop_zps'
+      file_xdx='trj_xdx_zps'
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -1167,6 +1172,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
-
+      IF ( tlm_bch /= 2 )  CALL istate_p  
       ! *** initialize the reference trajectory
       ! ------------
@@ -1187,22 +1191,11 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------
-      CALL zps_hde(nit000, tn, sn, rhd, gtu, gsu, gru, gtv, gsv, grv)
-
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
-
+      IF ( tlm_bch /= 2 ) CALL zps_hde(nit000, tn, sn, rhd, gtu, gsu, gru, gtv, gsv, grv)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------  
-         zgtu_out  (:,:) = gtu   (:,:)
-         zgtv_out  (:,:) = gtv   (:,:)  
-         zgsu_out  (:,:) = gsu   (:,:)
-         zgsv_out  (:,:) = gsv   (:,:) 
-         zgru_out  (:,:) = gru   (:,:)
-         zgrv_out  (:,:) = grv   (:,:)         
-
+      IF ( tlm_bch == 2 ) THEN
          !--------------------------------------------------------------------
          ! Initialize the tangent variables:
@@ -1241,4 +1234,11 @@
          zgru_wop  (:,:) = gru  (:,:)
          zgrv_wop  (:,:) = grv  (:,:)
+         CALL trj_rd_spl(file_xdx) 
+         zgtu_out  (:,:) = gtu  (:,:)
+         zgtv_out  (:,:) = gtv  (:,:)
+         zgsu_out  (:,:) = gsu  (:,:)
+         zgsv_out  (:,:) = gsv  (:,:)
+         zgru_out  (:,:) = gru  (:,:)
+         zgrv_out  (:,:) = grv  (:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -1471,3 +1471,4 @@
    !!======================================================================
 #endif
+#endif
 END MODULE zpshde_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/cla_dynspg_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/cla_dynspg_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/cla_dynspg_tam.F90	(revision 2587)
@@ -31,5 +31,6 @@
       & lwp,                 &
       & numout,              &  
-      & nit000
+      & nit000,              &
+      & nitend
    USE dom_oce       , ONLY: & ! Ocean space and time domain
       & mi0,                 &
@@ -330,5 +331,5 @@
       ! Control print
       ! -------------
-      IF( kt == nit000 ) THEN 
+      IF( kt == nitend ) THEN 
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'cla_dynspg_adj : cross land advection on surface '
@@ -486,7 +487,4 @@
       ! we convert in m3
       zempmed = zempmed * 1.e-3_wp
-
-!!!! AW: Adjoint of this????
-      IF( lk_mpp )   CALL mpp_sum( zempmed )      ! sum with other processors value
 
       ! minus 2 points in Red Sea and 3 in Atlantic 
@@ -504,4 +502,6 @@
       END DO
 
+      IF( lk_mpp )   CALL mpp_sum( zempmed )      ! sum with other processors value
+
       ! compute the emp in Mediterranean Sea
       ij0 =  96   ;   ij1 = 110
